// 004 u_09_casting
// 10 dec 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_09_casting;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    Memo1: TMemo;
    RichEdit1: TRichEdit;
    ListBox1: TListBox;
    Panel5: TPanel;
    Panel6: TPanel;
    Edit1: TEdit;
    Memo2: TMemo;
    string_cast_: TButton;
    Splitter2: TSplitter;
    surtypage_: TButton;
    pchar_: TButton;
    p_ansi_char_: TButton;
    p_ansi_char_call_: TButton;
    pchar_ansistring_: TButton;
    ansichar_char_: TButton;
    pointermath_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure string_cast_Click(Sender: TObject);
    procedure surtypage_Click(Sender: TObject);
    procedure pchar_Click(Sender: TObject);
    procedure p_ansi_char_Click(Sender: TObject);
    procedure p_ansi_char_call_Click(Sender: TObject);
    procedure pchar_ansistring_Click(Sender: TObject);
    procedure ansichar_char_Click(Sender: TObject);
    procedure pointermath_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses Character, u_display_unicode;

{$R *.dfm}

    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end; // display

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure do_display(p_string: String);
      var l_index: Integer;
      begin
        with Form1 do
        begin
          ListBox1.Items.Add(p_string);
          RichEdit1.Text:= RichEdit1.Text+ p_string;
          Memo2.Lines.Add(p_string);
          Edit1.Text:= Edit1.Text+ p_string;

          display(f_display_unicode_string(p_string));
          for l_index:= 1 to Length(p_string) do
            display(Format('%2d ', [l_index])+ p_string[l_index]);
        end; // with Form1
      end; // do_display

    procedure do_display_ansi_string(p_ansi_string: AnsiString);
      var l_index: Integer;
      begin
        with Form1 do
        begin
          ListBox1.Items.Add(p_ansi_string);
          RichEdit1.Text:= RichEdit1.Text+ p_ansi_string;
          Memo2.Lines.Add(p_ansi_string);
          Edit1.Text:= Edit1.Text+ p_ansi_string;

          display(f_display_ansi_string(p_ansi_string));
          for l_index:= 1 to Length(p_ansi_string) do
            display(Format('%2d %1x ', [l_index, Ord(p_ansi_string[l_index])])+ p_ansi_string[l_index]);
        end; // with Form1
      end; // do_display_ansi_string


    // -- surtypage

    type t_byte_array= Packed Array[0..3] of Byte;
         t_pt_byte_array= ^t_byte_array;

    procedure TForm1.surtypage_Click(Sender: TObject);
      var l_integer: Integer;
          l_pt_byte_array: t_pt_byte_array;
          l_result: String;
          l_index: Integer;
      begin
        l_integer:= $11223344;
        display('@integer addr   $'+ IntToHex(Integer(@l_integer), 4)+ ' integer value $'+ IntToHex(l_integer, 4));

        l_pt_byte_array:= t_pt_byte_array(@l_integer);
        l_result:= 'pointer addr    $'+ IntToHex(Integer(l_pt_byte_array), 4)+ ' array value $';
        for l_index:= 3 downto 0 do
          l_result:= l_result+ ' '+ IntToHex(l_pt_byte_array^[l_index], 2);
        display(l_result);
      end; // surtypage_Click

    procedure TForm1.string_cast_Click(Sender: TObject);
      var l_ansi_string: AnsiString;
      begin
        l_ansi_string:= 'abc';
        do_display(UnicodeString(l_ansi_string));

        with t_pt_new_string_header(Integer(l_ansi_string)- 12)^ do
          display(IntToStr(m_code_page));
        with t_pt_new_string_header(Integer(UnicodeString(l_ansi_string))- 12)^ do
          display(IntToStr(m_code_page));
      end; // ansistring_Click

    function f_test_pchar(p_pchar: pChar; var pv_pchar: pchar): pchar;
      var l_string, l_pv_string, l_result_string: String;
      begin
        l_string:= String(p_pchar);
        display(l_string);

        l_pv_string:= 'pv '+ l_string;
        display('param_v '+ String(l_pv_string));
        pv_pchar:= pChar(l_pv_string);

        l_result_string:= 'resu '+ l_string;
        Result:= pChar(l_result_string);
      end; // f_test_pchar

    procedure TForm1.pchar_Click(Sender: TObject);
      var l_string: String;
          l_pchar, l_pv_pchar, l_result_pchar: pChar;
          l_result_string: String;
      begin
        l_result_pchar:= f_test_pchar('abc', l_pv_pchar);
        display(String(l_result_pchar)+ ' param_v '+ String(l_pv_pchar)+ '<');

        l_string:= 'abc';
        // OK l_result_pchar:= f_test_pchar(@l_string[1], l_pv_pchar);
        l_result_pchar:= f_test_pchar(pChar(l_string), l_pv_pchar);
        display(String(l_result_pchar)+ ' param_v '+ String(l_pv_pchar)+ '<');

        display(String(f_test_pchar(pChar('abc'), l_pv_pchar))+ ' param_v '+ String(l_pv_pchar)+ '<');
      end; // pchar_Click

    procedure TForm1.p_ansi_char_Click(Sender: TObject);
      var l_string: String;
          l_p_ansi_char, l_pv_p_ansi_char, l_result_p_ansi_char: pAnsiChar;
          l_result_string: String;

          l_ansi_string: AnsiString;
      begin
        l_string:= 'abc';
(*
        with t_pt_new_string_header(Integer(l_string)- 12)^ do
          display(IntToStr(m_code_page)+ ' '+ f_byte_array_to_hex(m_bytes, 6));
*)
        l_p_ansi_char:= pAnsiChar(l_string);

        with t_pt_new_string_header(Integer(l_p_ansi_char)- 12)^ do
          display(IntToStr(m_code_page)+ ' '+ f_byte_array_to_hex(m_bytes, 6));

        l_ansi_string:= l_string;
        l_p_ansi_char:= pAnsiChar(l_ansi_string);

        with t_pt_new_string_header(Integer(l_p_ansi_char)- 12)^ do
          display(IntToStr(m_code_page)+ ' '+ f_byte_array_to_hex(m_bytes, 6));
      end; // p_ansi_char_Click

    function f_test_p_ansi_char(p_p_ansi_char: pAnsiChar; var pv_p_ansi_char: pAnsichar): pAnsichar;
      var l_string, l_pv_string, l_result_string: String;
          l_pv_ansi_string, l_result_ansi_string: AnsiString;
      begin
        l_string:= String(p_p_ansi_char);
        display('param '+ l_string);

        l_pv_string:= 'pv '+ l_string;
        display('param_v '+ String(l_pv_string));
        // NO 1stChar pv_p_ansi_char:= pAnsiChar(l_pv_string);
        l_pv_ansi_string:= 'pv '+ l_string;
        pv_p_ansi_char:= pAnsiChar(l_pv_ansi_string);

        l_result_string:= 'resu '+ l_string;
        // NO 1st char Result:= pAnsiChar(l_result_string);
        l_result_ansi_string:= 'resu '+ l_string;
        Result:= pAnsiChar(l_result_ansi_string);
      end; // f_test_p_ansi_char

    procedure TForm1.p_ansi_char_call_Click(Sender: TObject);
      var l_string: String;
          l_p_ansi_char, l_pv_p_ansi_char, l_result_p_ansi_char: pAnsiChar;
          l_result_string: String;
      begin
        l_result_p_ansi_char:= f_test_p_ansi_char('abc', l_pv_p_ansi_char);
        display(String(l_result_p_ansi_char)+ ' param_v '+ String(l_pv_p_ansi_char)+ '<');
(*
        l_string:= 'abc';
        // NO l_result_p_ansi_char:= f_test_p_ansi_char(pAnsiChar(l_string), l_pv_p_ansi_char);
        display(String(l_result_p_ansi_char)+ ' param_v '+ String(l_pv_p_ansi_char)+ '<');
*)
        display(String(f_test_p_ansi_char('abc', l_pv_p_ansi_char))+ ' param_v '+ String(l_pv_p_ansi_char)+ '<');
      end; // p_ansi_char_call_Click


    procedure TForm1.pchar_ansistring_Click(Sender: TObject);
      var l_ansi_string: AnsiString;
          l_pchar: pChar;
          l_string: String;
      begin
        l_ansi_string:= 'abc';
        l_pchar:= pChar(l_ansi_string);
        l_string:= String(l_pchar);
        display(l_string);
        with t_pt_new_string_header(Integer(l_string)- 12)^ do
          display(IntToStr(m_code_page)+ ' '+ f_byte_array_to_hex(m_bytes, 6));
      end;

    procedure TForm1.ansichar_char_Click(Sender: TObject);
      var l_char: Char;
          l_ansi_char: AnsiChar;
      begin
        l_char:= '';
        l_ansi_char:= AnsiChar(l_char);
        display(Format('$%4x   %2x ', [Word(l_char), Byte(l_ansi_Char)]));
      end; // ansichar_casting_Click

    procedure TForm1.pointermath_Click(Sender: TObject);
      var l_integer_array: array of Integer;
          l_pt_integer: ^Integer;
          writeln
      begin
        SetLength(l_integer_array, 3);
        l_integer_array[0]:= $11111111;
        l_integer_array[1]:= $22222222;
        l_integer_array[2]:= $33333333;
        (*$Pointermath On*)
        l_pt_integer:= @ l_integer_array[0];
        display(IntToHex(l_pt_integer^, 4));
        Inc(l_pt_integer);
        display(IntToHex(l_pt_integer^, 4));
        l_pt_integer:= l_pt_integer+ 1;
        display(IntToHex(l_pt_integer^, 4));
        (*$Pointermath Off*)
        // -- not accepted outside $POINTERMATH l_pt_integer:= l_pt_integer+ 1;
      end;

    end.

// utiliser PAnsiChar(AnsiString(s))
